#include "fxlib.h"
#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "MonochromeLib.h"

#include "revolution.h"

#include "image.h"

#define STORAGE '\\','\\','f','l','s','0','\\'
#define SD '\\','\\','c','r','d','0','\\'
#define EXTEND '*','.','b','m','p'
#define MEMORY SD

#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
#define SCROLL_WIDTH 6

float zoomlevels[5];
int nzooms=0;

float zoom_max;
float zoom_min;

float zoom;

void setzoomlimits()
{	int i;
	int f=0;
	zoom_max=zoom;
	for(i=0;i<nzooms && !f;i++)
		if(zoomlevels[i]>zoom)
		{	f=1;
			zoom_max=zoomlevels[i];
		}
	f=0;
	zoom_min=zoom;
	for(i=nzooms-1;i>=0 && !f;i--)
		if(zoomlevels[i]<zoom)
		{	f=1;
			zoom_min=zoomlevels[i];
		}
}

void addzoomlevel(float zoom)
{	int i;
	int ins=-1;
	for(i=0;i<nzooms && ins<0;i++)
		if(zoomlevels[i]>zoom)
			ins=i;
		else if(zoomlevels[i]==zoom)
			return;
	if(ins>=0)
	{	for(i=nzooms-1;i>=ins;i--)
			zoomlevels[i+1]=zoomlevels[i];
		zoomlevels[ins]=zoom;
	}
	else
		zoomlevels[nzooms]=zoom;
	nzooms++;
}

Clear()
{
    Bdisp_AllClr_VRAM();
    locate(1,1);
    PrintRev("      mViewer GX       ");
}

WaitKey() {
	unsigned int key=0;
	while(!key)
		GetKey(&key);
}

PrintN(int n) {
	char tmp[16];
	sprintf(tmp, "%ld", n);
	Print(tmp);
}

max(int a, int b) {
	if(a>b)	return a;
	return b;
}

min(int a, int b) {
	if(a<b)	return a;
	return b;
}

Error(unsigned char* msg) {
	Clear();
	locate(1,3);
	Print("Error :");
	locate(1,4);
	Print(msg);
	locate(1,8);
	Print("Press a key");
	WaitKey();
}

unsigned char contrast1=ML_CONTRAST_NORMAL;
unsigned char contrast2=ML_CONTRAST_NORMAL;

int LireFichier(FONTCHARACTER nomDuFichier[])
{   unsigned int key=0;
    int res=0;
    unsigned char r, g, b, buffer1[1024], buffer2[1024], offbuffer1[1024], offbuffer2[1024], *image = 0, color;
    unsigned char* palette;
    int fichier = Bfile_OpenFile(nomDuFichier, _OPENMODE_READ), i, j,x,y;
    fileheader fheader;
    dataheader dheader;
    int trunk;
    float x0=0;
    float y0=0;
    float xf,yf;
    float d=1;
    int xold=-1;
    int yold=-1;
    unsigned int e;
    int m;
    int rstep, lstep, ustep, dstep;
    float istep, ostep;	// for progressive zoom & scrolling
    int step;
    float zxmax,zymax,zxmin,zymin;
    int zwidth, zwidthold;
    int zheight, zheightold;
    int torelease;
    zoom=1.0;
    if(readFileHeader(&fheader,fichier)) {	
	if(fheader.type) { // support BMP
		if(readDataHeader(&dheader,fichier,&fheader)) {
			if(fheader.type==1 && (dheader.compression==0 || dheader.compression==1 || dheader.compression==3)) {	// formats grs
				if(dheader.indexedcolors)
					palette=(unsigned char*)readPalette(&dheader, fichier, &fheader);
				image =(unsigned char*)readImage(&dheader, palette, fichier, &fheader);
				if(image) {
/*					if(dheader.bits!=1) {
						if(!buffer1) buffer1=(unsigned char*)malloc(1024);
						if(!buffer2) buffer2=(unsigned char*)malloc(1024);
						if(!offbuffer1) offbuffer1=(unsigned char*)malloc(1024);
						if(!offbuffer2) offbuffer2=(unsigned char*)malloc(1024);
						if(!buffer1 || !buffer2 || !offbuffer1 || !offbuffer2) {
							free(image);
							image=0;
						}
					}*/
				}
				if(image) {
					zxmax=dheader.width/(float)SCREEN_WIDTH;		
					zymax=dheader.height/(float)SCREEN_HEIGHT;
					zoom=1.0;
					zoom=(zoom > 1.0) ? zoom : 1.0;
					nzooms=0;
					zxmin=zxmax*(float)SCREEN_WIDTH;
					zymin=zymax*(float)SCREEN_HEIGHT;
					addzoomlevel(0.0125);
					addzoomlevel(1.0);
					addzoomlevel(zxmax);
					addzoomlevel(zymax);
					addzoomlevel((zxmin>zymin) ? zymin : zxmin);
					setzoomlimits();
					e=1;
					m=0;
					// Binary-Events e:
					//  * -> refresh
					//  2 -> scroll up
					//  4 -> scroll down
					//  8 -> scroll left
					// 16 -> scroll right
					// 32 -> zoom
					// 64 -> dezoom
					rstep=0; lstep=0; ustep=0; dstep=0;
					istep=0.0;ostep=0.0;	// for progressive zoom & scrolling
					torelease=0;	// forbids action repeat before key is released: bit1=keyCTRL | bit2=keyC
					zwidth=(int)(dheader.width/zoom), zheight=(int)(dheader.height)/zoom;	// actual (zoomed) image dimensions
					zwidthold=zwidth, zheightold=zheight;	// keeps previous (zoomed) image dimensions
					if(dheader.bits!=1) {
						ML_set_contrast(contrast2);
						GrayLinkBuffers(buffer1, buffer2);
						GrayInit(3273, 1454);
					}
					while(IsKeyUp(KEY_CTRL_EXIT) && !res) {
						step=max(1.0F,(int)(1.0F/zoom));
						if(!(e&2)) ustep=step;
						else ustep+=step;
						if(!(e&4)) dstep=step;
						else dstep+=step;
						if(!(e&8)) lstep=step;
						else lstep+=step;
						if(!(e&16)) rstep=step;
						else rstep+=step;
						if(!(e&32)) istep=0.0;
						else istep+=0.01;
						if(!(e&64)) ostep=0.0;
						else ostep+=0.01;
						if(e || m)
						{	if(!e) m=0;
							if(e&2	)
								y0-=ustep;
							if(e&4	)
								y0+=dstep;
							if(e&8	)
								x0-=lstep;
							if(e&16	)
								x0+=rstep;
							if(e&32){//zoom in
								//if(zoom-istep<1.0) istep=zoom-1.0;
								//if(zoom-istep<0.025) istep=zoom-0.025;
								if(zoom-istep<zoom_min) istep=zoom-zoom_min;
								//if(zoom-istep<=0.0) istep=0;
								zoom-=istep;
								if(zoom<=zoom_min)
								{	setzoomlimits();
									istep=0;
								}
								zwidthold=zwidth;
								zheightold=zheight;
								zwidth=(int)(dheader.width/zoom);
								zheight=(int)(dheader.height/zoom);
								x0 = (x0-SCREEN_WIDTH/2)*zwidth/zwidthold+SCREEN_WIDTH/2;
								y0 = (y0-SCREEN_HEIGHT/2)*zheight/zheightold+SCREEN_HEIGHT/2;
							}
							if(e&64){//zoom out
								if(zoom+ostep>zoom_max) ostep=zoom_max-zoom;
								zoom+=ostep;
								if(zoom>=zoom_max)
								{	setzoomlimits();
									ostep=0;
								}
								zwidthold=zwidth;
								zheightold=zheight;
								zwidth=(int)(dheader.width/zoom);
								zheight=(int)(dheader.height/zoom);
								x0 = (x0-SCREEN_WIDTH/2)*zwidth/zwidthold+SCREEN_WIDTH/2;
								y0 = (y0-SCREEN_HEIGHT/2)*zheight/zheightold+SCREEN_HEIGHT/2;
							}
							if(e) m=1;
							x0 = (x0+zwidth  < SCREEN_WIDTH ) ?
								(SCREEN_WIDTH  - zwidth ): x0;
							y0 = (y0+zheight < SCREEN_HEIGHT) ?
								(SCREEN_HEIGHT - zheight): y0;
							if(y0>0) y0=0;
							if(x0>0) x0=0;
							if(y0>0) y0=0;
							if(x0>0) x0=0;
							if(dheader.bits!=1) {
								 memset(offbuffer1,0,1024);
								 memset(offbuffer2,0,1024);
							}
//							else
//								if(dheader.width<SCREEN_WIDTH || dheader.height<SCREEN_HEIGHT)
//									Bdisp_AllClr_VRAM();
							 for(y=0,yf=(int)-y0*zoom;y<SCREEN_HEIGHT && yf<dheader.height;y++,yf+=zoom) {
							 	for(x=0,xf=(int)-x0*zoom;x<SCREEN_WIDTH && xf<dheader.width;x++,xf+=zoom) {
									 color=getImgPixel(image,(int)yf,(int)xf,&dheader);
									if(dheader.bits!=1) {
										switch(color) {
											case 0:
												PlotPixel(x, y, offbuffer1, 1);
												PlotPixel(x, y, offbuffer2, 1);
												break;
											case 1:
												PlotPixel(x, y, offbuffer2, 1);
												break;
											case 2:
												PlotPixel(x, y, offbuffer1, 1);
												break;
										}
									}
									else {
										switch(color) {
											case 0:
												Bdisp_SetPoint_VRAM(x,y,1);
												break;
											case 1:
												Bdisp_SetPoint_VRAM(x,y,0);
												break;
										}
									}
								}
							}
							trunk=0;
							if(dheader.width/zoom>SCREEN_WIDTH) trunk=1;
							if(m && dheader.height/zoom>SCREEN_HEIGHT)
							{	if(dheader.bits==1) {
									Bdisp_DrawLineVRAM(SCREEN_WIDTH-1,0,SCREEN_WIDTH-1,SCREEN_HEIGHT-1-SCROLL_WIDTH);
									Bdisp_DrawLineVRAM(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										Bdisp_ClearLineVRAM(SCREEN_WIDTH-i-1,0,SCREEN_WIDTH-i-1,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk);
									Bdisp_DrawLineVRAM(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-2,0);
									Bdisp_DrawLineVRAM(SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,SCREEN_WIDTH-2,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										Bdisp_DrawLineVRAM(SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight,SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight+(int)((SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)*zoom/zymax));
								}
								else {
									DrawLine(SCREEN_WIDTH-1,0,SCREEN_WIDTH-1,SCREEN_HEIGHT-1-SCROLL_WIDTH,offbuffer1,1);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer1,1);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										DrawLine(SCREEN_WIDTH-i-1,0,SCREEN_WIDTH-i-1,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer1,0);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-2,0,offbuffer1,1);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,SCREEN_WIDTH-2,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer1,1);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										DrawLine(SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight,SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight+(int)((SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)*zoom/zymax),offbuffer1,1);
									DrawLine(SCREEN_WIDTH-1,0,SCREEN_WIDTH-1,SCREEN_HEIGHT-1-SCROLL_WIDTH,offbuffer2,1);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer2,1);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										DrawLine(SCREEN_WIDTH-i-1,0,SCREEN_WIDTH-i-1,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer2,0);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,0,SCREEN_WIDTH-2,0,offbuffer2,1);
									DrawLine(SCREEN_WIDTH-SCROLL_WIDTH,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,SCREEN_WIDTH-2,SCREEN_HEIGHT-1-SCROLL_WIDTH*trunk,offbuffer2,1);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										DrawLine(SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight,SCREEN_WIDTH-i-1,2-y0*(SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)/zheight+(int)((SCREEN_HEIGHT-4-SCROLL_WIDTH*trunk)*zoom/zymax),offbuffer2,1);
								}
							}
							if(m && dheader.width/zoom>SCREEN_WIDTH)
							{	if(dheader.bits==1) {
									Bdisp_DrawLineVRAM(0,SCREEN_HEIGHT-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-1);
									Bdisp_DrawLineVRAM(0,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										Bdisp_ClearLineVRAM(0,SCREEN_HEIGHT-i-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-i-1);
									Bdisp_DrawLineVRAM(0,SCREEN_HEIGHT-SCROLL_WIDTH,0,SCREEN_HEIGHT-2);
									Bdisp_DrawLineVRAM(SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-2);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										Bdisp_DrawLineVRAM(2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth,SCREEN_HEIGHT-i-1,2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth+(int)((SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)*zoom/zxmax),SCREEN_HEIGHT-i-1);
								}
								else {
									DrawLine(0,SCREEN_HEIGHT-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-1,offbuffer1,1);
									DrawLine(0,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH,offbuffer1,1);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										DrawLine(0,SCREEN_HEIGHT-i-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-i-1,offbuffer1,0);
									DrawLine(0,SCREEN_HEIGHT-SCROLL_WIDTH,0,SCREEN_HEIGHT-2,offbuffer1,1);
									DrawLine(SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-2,offbuffer1,1);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										DrawLine(2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth,SCREEN_HEIGHT-i-1,2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth+(int)((SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)*zoom/zxmax),SCREEN_HEIGHT-i-1,offbuffer1,1);
									DrawLine(0,SCREEN_HEIGHT-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-1,offbuffer2,1);
									DrawLine(0,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH,offbuffer2,1);
									for(i=1;i<SCROLL_WIDTH-1;i++)
										DrawLine(0,SCREEN_HEIGHT-i-1,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-i-1,offbuffer2,0);
									DrawLine(0,SCREEN_HEIGHT-SCROLL_WIDTH,0,SCREEN_HEIGHT-2,offbuffer2,1);
									DrawLine(SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-SCROLL_WIDTH,SCREEN_WIDTH-1-SCROLL_WIDTH*trunk,SCREEN_HEIGHT-2,offbuffer2,1);
									for(i=2;i<SCROLL_WIDTH-2;i++)
										DrawLine(2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth,SCREEN_HEIGHT-i-1,2-x0*(SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)/zwidth+(int)((SCREEN_WIDTH-4-SCROLL_WIDTH*trunk)*zoom/zxmax),SCREEN_HEIGHT-i-1,offbuffer2,1);
								}
							}
							if(dheader.bits!=1) {
								memcpy(buffer1,offbuffer1,1024);
								memcpy(buffer2,offbuffer2,1024);
							}
							else {
								ML_set_contrast(contrast1);
								Bdisp_PutDisp_DD();
							}
							e=0;
						}
						xold=x;
						yold=y;
						if(!IsKeyUp(KEY_CTRL_UP) && IsKeyUp(KEY_CHAR_5) && y0<0) e|=4;
						if(!IsKeyUp(KEY_CTRL_DOWN) && IsKeyUp(KEY_CHAR_5) && y0+zheight  > SCREEN_HEIGHT) e|=2;
						if(!IsKeyUp(KEY_CTRL_LEFT) && IsKeyUp(KEY_CHAR_5) && x0<0) e|=16;
						if(!IsKeyUp(KEY_CTRL_RIGHT) && IsKeyUp(KEY_CHAR_5) && x0+zwidth  > SCREEN_WIDTH) e|=8;
						if(!IsKeyUp(KEY_CHAR_MULT))	e|=32;
						if(!IsKeyUp(KEY_CHAR_DIV))	e|=64;
						if(!(e&64) && !(e&32))
							setzoomlimits();
						if (!IsKeyUp(KEY_CHAR_PLUS)) {
							if(dheader.bits!=1)	{ if(contrast2<ML_CONTRAST_MAX) { contrast2++; ML_set_contrast(contrast2); } }
							else				{ if(contrast1<ML_CONTRAST_MAX) { contrast1++; ML_set_contrast(contrast1); } }
						} else 	if (!IsKeyUp(KEY_CHAR_MINUS)) {
							if(dheader.bits!=1)	{ if(contrast2>ML_CONTRAST_MIN) { contrast2--; ML_set_contrast(contrast2); } }
							else				{ if(contrast1>ML_CONTRAST_MIN) { contrast1--; ML_set_contrast(contrast1); } }
						}
						if(!(torelease&4) && (!IsKeyUp(KEY_CHAR_2) || !IsKeyUp(KEY_CHAR_1) || !IsKeyUp(KEY_CHAR_3) || !IsKeyUp(KEY_CTRL_DOWN) && !IsKeyUp(KEY_CHAR_5)))
						{	y0-=(int)(SCREEN_HEIGHT);
							torelease|=4;
							e|=1;
						}
						if(!(torelease&8) && (!IsKeyUp(KEY_CHAR_8) || !IsKeyUp(KEY_CHAR_7) || !IsKeyUp(KEY_CHAR_9) || !IsKeyUp(KEY_CTRL_UP) && !IsKeyUp(KEY_CHAR_5)))
						{	y0+=(int)(SCREEN_HEIGHT);
							torelease|=8;
							e|=1;
						}
						if(!(torelease&16) && (!IsKeyUp(KEY_CHAR_4) || !IsKeyUp(KEY_CHAR_7) || !IsKeyUp(KEY_CHAR_1) || !IsKeyUp(KEY_CTRL_LEFT) && !IsKeyUp(KEY_CHAR_5)))
						{	x0+=(int)(SCREEN_WIDTH);
							torelease|=16;
							e|=1;
						}
						if(!(torelease&32) && (!IsKeyUp(KEY_CHAR_6) || !IsKeyUp(KEY_CHAR_3) || !IsKeyUp(KEY_CHAR_9) || !IsKeyUp(KEY_CTRL_RIGHT) && !IsKeyUp(KEY_CHAR_5)))
						{	x0-=(int)(SCREEN_WIDTH);
							torelease|=32;
							e|=1;
						}
						if(torelease)	// no-repeat actions
						{	if((IsKeyUp(KEY_CHAR_5)) || (IsKeyUp(KEY_CHAR_2) && IsKeyUp(KEY_CHAR_1) && IsKeyUp(KEY_CHAR_3) && IsKeyUp(KEY_CTRL_DOWN)))		torelease &= ~4;
							if((IsKeyUp(KEY_CHAR_5)) || (IsKeyUp(KEY_CHAR_8) && IsKeyUp(KEY_CHAR_7) && IsKeyUp(KEY_CHAR_9) && IsKeyUp(KEY_CTRL_UP)))		torelease &= ~8;
							if((IsKeyUp(KEY_CHAR_5)) || (IsKeyUp(KEY_CHAR_4) && IsKeyUp(KEY_CHAR_1) && IsKeyUp(KEY_CHAR_7) && IsKeyUp(KEY_CTRL_LEFT)))		torelease &= ~16;
							if((IsKeyUp(KEY_CHAR_5)) || (IsKeyUp(KEY_CHAR_6) && IsKeyUp(KEY_CHAR_3) && IsKeyUp(KEY_CHAR_9) && IsKeyUp(KEY_CTRL_RIGHT)))		torelease &= ~32;
						}
						if(!IsKeyUp(KEY_CHAR_LPAR)) res=-1;
						if(!IsKeyUp(KEY_CHAR_RPAR)) res=1;
					}
					if(dheader.bits!=1 && !res) {
						GrayEnd();
						Reset_Calc();
						ML_set_contrast(contrast1);
					}
/*					if(dheader.bits!=1) {
						if(buffer1) { free(buffer1); buffer1=0; }
						if(buffer2) { free(buffer1); buffer2=0; }
						if(offbuffer1) { free(offbuffer1); offbuffer1=0; }
						if(offbuffer2) { free(offbuffer1); offbuffer2=0; }
					}*/
					free(image);
				}
				else	Error("in BMP data");
//				if(dheader.indexedcolors)
//					free(palette);
			}
			else	Error("Invalid compression");
		}
		else	Error("in BMP data header");
	}
	else	Error("This is no BMP file");
    }
    else	Error("This is no BMP file");
    Bfile_CloseFile(fichier);
    return res;
}

FileName(unsigned char nom[], FONTCHARACTER file[])
{
    sprintf(nom, "%c%c%c%c%c%c%c%c%c%c%c%c%c", file[0], file[1], file[2], file[3], file[4], file[5], file[6], file[7], file[8], file[9], file[10], file[11], file[12]);
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
    unsigned nombreDeFichiers = 1, *taille = 0;
    int fileHandle, i, j;
    FILE_INFO fileInfo;
    FONTCHARACTER foundFile[13], *liste = 0, storage[]={MEMORY,EXTEND,0};
    unsigned int key;
    memclean(4096);
    while(1)
    {   ML_set_contrast(ML_CONTRAST_NORMAL);
        Clear();
        locate(2, 3);Print("F1: Storage memory");
        locate(2, 4);Print("F2: SD Card");
        locate(1,8);
        PrintRev("STO");
        Print(" ");
        PrintRev("SDC");
        GetKey(&key);
        switch(key)
        {
            case KEY_CTRL_F1: explorer("\\\\fls0\\"); break;
            case KEY_CTRL_F2: explorer("\\\\crd0\\"); break;
        }
    }
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section

